'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _DesktopDeviceController = require('./Desktop/DesktopDeviceController');

var _DesktopDeviceController2 = _interopRequireDefault(_DesktopDeviceController);

var _MobileDeviceController = require('./Mobile/MobileDeviceController');

var _MobileDeviceController2 = _interopRequireDefault(_MobileDeviceController);

var _HeadMountedDisplay = require('./HeadMountedDisplay/HeadMountedDisplay');

var _HeadMountedDisplay2 = _interopRequireDefault(_HeadMountedDisplay);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var isMobile = {
    Android: function Android() {
        return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function BlackBerry() {
        return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function iOS() {
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Opera: function Opera() {
        return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function Windows() {
        return navigator.userAgent.match(/IEMobile/i) || navigator.userAgent.match(/WPDesktop/i);
    },
    any: function any() {
        return isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows();
    }
};

var Device = function Device(space) {
    _classCallCheck(this, Device);

    if (navigator.getVRDisplays !== undefined) {

        console.log('[Device] - Detected: Desktop, VR: true');

        return new _HeadMountedDisplay2.default(space);
    } else {

        if (isMobile.any()) {

            console.log('[Device] - Detected: Mobile, VR: false');

            return new _MobileDeviceController2.default(space);
        } else {

            console.log('[Device] - Detected: Desktop, VR: false');

            return new _DesktopDeviceController2.default(space);
        }
    }
};

exports.default = Device;