'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _three = require('three');

var _Meta = require('../Meta');

var _Meta2 = _interopRequireDefault(_Meta);

var _Graphics = require('../Graphics/Graphics');

var _Graphics2 = _interopRequireDefault(_Graphics);

var _Plane = require('../Graphics/Geometries/Plane');

var _Plane2 = _interopRequireDefault(_Plane);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _DEFAULT = {
  COLOR: 0xf08e91
};

var Grid = function Grid(props) {
  _classCallCheck(this, Grid);

  var _color = props !== undefined && props.color !== undefined ? props.color : _DEFAULT.COLOR;

  return new _Meta2.default({

    physics: null,

    graphics: new _Graphics2.default({

      mesh: new _three.GridHelper(1000, 1000, _color, _color).translateY(.001) }, true) });
};

exports.default = Grid;