'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _three = require('three');

var _Graphics = require('../Graphics');

var _Graphics2 = _interopRequireDefault(_Graphics);

var _Space = require('../../../Space');

var _Space2 = _interopRequireDefault(_Space);

var _Desktop = require('../../../Device/Desktop/Desktop');

var _Desktop2 = _interopRequireDefault(_Desktop);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _DEFAULT = {
    RADIUS: .5,
    SEGMENTS: 32,
    SCALE: 1
};

var Sphere = function Sphere() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var stop = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    _classCallCheck(this, Sphere);

    if (typeof props === 'boolean') stop = props;

    var scale = _DEFAULT.SCALE;

    var _radius = props.r || props.radius || _DEFAULT.RADIUS;

    _radius *= scale;

    if (typeof props === 'number') _radius = props;

    this.geometry = new _three.SphereGeometry(_radius, _DEFAULT.SEGMENTS, _DEFAULT.SEGMENTS);
    this.geometry.rotateX(-Math.PI / 2);

    this.type = 'sphere';
    return stop ? this.geometry : new _Graphics2.default(this);
};

exports.default = Sphere;