'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _three = require('three');

var _Meta = require('../Meta');

var _Meta2 = _interopRequireDefault(_Meta);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _DEFAULT = {
  TYPE: 'box' };

var Graphics = function () {
  function Graphics(props) {
    var stop = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    _classCallCheck(this, Graphics);

    this.geometry = props !== undefined && props.geometry !== undefined && props.geometry !== true ? props.geometry : new _three.CubeGeometry();
    this.material = props !== undefined && props.material !== undefined && props.material !== true ? props.material : new _three.MeshPhongMaterial({ color: Math.random() * 0xffffff, side: _three.DoubleSide });

    this.type = props !== undefined && props.type !== undefined && props.type !== true ? props.type : _DEFAULT.TYPE;

    this.mesh = props !== undefined && props.mesh !== undefined && props.mesh !== true ? props.mesh : new _three.Mesh(this.geometry, this.material);

    this.physics = true;

    if (props.p !== undefined) this.physics = props.p;

    if (props.physics !== undefined) this.physics = props.physics;

    if (stop) return this;

    return new _Meta2.default({ graphics: this, physics: this.physics });
  }

  _createClass(Graphics, [{
    key: 'color',
    value: function color(_color) {
      this.mesh.material.color.set(_color);
    }
  }, {
    key: 'add',
    value: function add(instance) {
      this.geometry = instance;
    }
  }]);

  return Graphics;
}();

exports.default = Graphics;